/* NewCardDialog.c generated by valac 0.56.12, the Vala compiler
 * generated from NewCardDialog.vala, do not modify */

/*
* Copyright 2016-2020 elementary, Inc. (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "io.elementary.switchboard.wallet.h"
#include <libsecret/secret.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <granite.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>

enum  {
	WALLET_NEW_CARD_DIALOG_0_PROPERTY,
	WALLET_NEW_CARD_DIALOG_COLLECTION_PROPERTY,
	WALLET_NEW_CARD_DIALOG_NUM_PROPERTIES
};
static GParamSpec* wallet_new_card_dialog_properties[WALLET_NEW_CARD_DIALOG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _secret_value_unref0(var) ((var == NULL) ? NULL : (var = (secret_value_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _secret_schema_unref0(var) ((var == NULL) ? NULL : (var = (secret_schema_unref (var), NULL)))
typedef struct _WalletNewCardDialogCreateSecretItemData WalletNewCardDialogCreateSecretItemData;
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

struct _WalletNewCardDialogPrivate {
	SecretCollection* _collection;
	GtkButton* pay_button;
	GtkEntry* card_expiration_entry;
	GtkEntry* card_cvc_entry;
	WalletCardNumberEntry* card_number_entry;
	gboolean card_valid;
	gboolean expiration_valid;
	gboolean cvc_valid;
};

struct _WalletNewCardDialogCreateSecretItemData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	WalletNewCardDialog* self;
	SecretSchema* schema;
	SecretSchema* _tmp0_;
	gchar* brand;
	WalletCardNumberEntry* _tmp1_;
	WalletCardNumberEntryCardType _tmp2_;
	WalletCardNumberEntryCardType _tmp3_;
	gchar* _tmp4_;
	GHashTable* attributes;
	GHashFunc _tmp5_;
	GEqualFunc _tmp6_;
	GHashTable* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	GtkEntry* _tmp11_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* secret;
	WalletCardNumberEntry* _tmp15_;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
	GtkEntry* _tmp18_;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
	gchar* _tmp21_;
	SecretValue* secret_value;
	SecretValue* _tmp22_;
	gchar* last_four;
	WalletCardNumberEntry* _tmp23_;
	const gchar* _tmp24_;
	const gchar* _tmp25_;
	WalletCardNumberEntry* _tmp26_;
	const gchar* _tmp27_;
	const gchar* _tmp28_;
	gint _tmp29_;
	gint _tmp30_;
	gchar* _tmp31_;
	gchar* label;
	gchar* _tmp32_;
	SecretCollection* _tmp33_;
	SecretItem* _tmp34_;
	SecretItem* _tmp35_;
	GError* _error_;
	GError* _tmp36_;
	const gchar* _tmp37_;
	GError* _inner_error0_;
};

static gint WalletNewCardDialog_private_offset;
static gpointer wallet_new_card_dialog_parent_class = NULL;

static void wallet_new_card_dialog_create_secret_item_data_free (gpointer _data);
static void wallet_new_card_dialog_create_secret_item (WalletNewCardDialog* self,
                                                GAsyncReadyCallback _callback_,
                                                gpointer _user_data_);
static void wallet_new_card_dialog_create_secret_item_finish (WalletNewCardDialog* self,
                                                       GAsyncResult* _res_);
static gboolean wallet_new_card_dialog_create_secret_item_co (WalletNewCardDialogCreateSecretItemData* _data_);
static void _g_free0_ (gpointer var);
static void wallet_new_card_dialog_create_secret_item_ready (GObject* source_object,
                                                      GAsyncResult* _res_,
                                                      gpointer _user_data_);
static void wallet_new_card_dialog_validate_card_number (WalletNewCardDialog* self,
                                                  const gchar* numbers);
static void wallet_new_card_dialog_validate_expiration (WalletNewCardDialog* self,
                                                 const gchar* expiration);
static void wallet_new_card_dialog_validate_cvc (WalletNewCardDialog* self,
                                          const gchar* cvc);
static void wallet_new_card_dialog_validate_form (WalletNewCardDialog* self);
static GObject * wallet_new_card_dialog_constructor (GType type,
                                              guint n_construct_properties,
                                              GObjectConstructParam * construct_properties);
static void _wallet_new_card_dialog___lambda8_ (WalletNewCardDialog* self,
                                         gint response_id);
static void __wallet_new_card_dialog___lambda8__gtk_dialog_response (GtkDialog* _sender,
                                                              gint response_id,
                                                              gpointer self);
static void _wallet_new_card_dialog___lambda9_ (WalletNewCardDialog* self);
static void __wallet_new_card_dialog___lambda9__gtk_editable_changed (GtkEditable* _sender,
                                                               gpointer self);
static void _wallet_new_card_dialog___lambda10_ (WalletNewCardDialog* self);
static void __wallet_new_card_dialog___lambda10__gtk_editable_changed (GtkEditable* _sender,
                                                                gpointer self);
static gboolean _wallet_new_card_dialog___lambda11_ (WalletNewCardDialog* self);
static gboolean __wallet_new_card_dialog___lambda11__gtk_widget_focus_out_event (GtkWidget* _sender,
                                                                          GdkEventFocus* event,
                                                                          gpointer self);
static void _wallet_new_card_dialog___lambda12_ (WalletNewCardDialog* self);
static void __wallet_new_card_dialog___lambda12__gtk_editable_changed (GtkEditable* _sender,
                                                                gpointer self);
static void wallet_new_card_dialog_finalize (GObject * obj);
static GType wallet_new_card_dialog_get_type_once (void);
static void _vala_wallet_new_card_dialog_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_wallet_new_card_dialog_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);

static inline gpointer
wallet_new_card_dialog_get_instance_private (WalletNewCardDialog* self)
{
	return G_STRUCT_MEMBER_P (self, WalletNewCardDialog_private_offset);
}

WalletNewCardDialog*
wallet_new_card_dialog_construct (GType object_type,
                                  SecretCollection* collection)
{
	WalletNewCardDialog * self = NULL;
	g_return_val_if_fail (collection != NULL, NULL);
	self = (WalletNewCardDialog*) g_object_new (object_type, "collection", collection, NULL);
	return self;
}

WalletNewCardDialog*
wallet_new_card_dialog_new (SecretCollection* collection)
{
	return wallet_new_card_dialog_construct (WALLET_TYPE_NEW_CARD_DIALOG, collection);
}

static void
wallet_new_card_dialog_create_secret_item_data_free (gpointer _data)
{
	WalletNewCardDialogCreateSecretItemData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (WalletNewCardDialogCreateSecretItemData, _data_);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
wallet_new_card_dialog_create_secret_item (WalletNewCardDialog* self,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_)
{
	WalletNewCardDialogCreateSecretItemData* _data_;
	WalletNewCardDialog* _tmp0_;
	g_return_if_fail (self != NULL);
	_data_ = g_slice_new0 (WalletNewCardDialogCreateSecretItemData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, wallet_new_card_dialog_create_secret_item_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	wallet_new_card_dialog_create_secret_item_co (_data_);
}

static void
wallet_new_card_dialog_create_secret_item_finish (WalletNewCardDialog* self,
                                                  GAsyncResult* _res_)
{
	WalletNewCardDialogCreateSecretItemData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static void
_g_free0_ (gpointer var)
{
	var = (g_free (var), NULL);
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
	end = _tmp0_;
	_tmp1_ = end;
	if (_tmp1_ == NULL) {
		result = maxlen;
		return result;
	} else {
		gchar* _tmp2_;
		_tmp2_ = end;
		result = (glong) (_tmp2_ - str);
		return result;
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	if (offset >= ((glong) 0)) {
		_tmp0_ = len >= ((glong) 0);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		string_length = string_strnlen ((gchar*) self, offset + len);
	} else {
		gint _tmp1_;
		gint _tmp2_;
		_tmp1_ = strlen (self);
		_tmp2_ = _tmp1_;
		string_length = (glong) _tmp2_;
	}
	if (offset < ((glong) 0)) {
		offset = string_length + offset;
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
	} else {
		g_return_val_if_fail (offset <= string_length, NULL);
	}
	if (len < ((glong) 0)) {
		len = string_length - offset;
	}
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
	result = _tmp3_;
	return result;
}

static void
wallet_new_card_dialog_create_secret_item_ready (GObject* source_object,
                                                 GAsyncResult* _res_,
                                                 gpointer _user_data_)
{
	WalletNewCardDialogCreateSecretItemData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	wallet_new_card_dialog_create_secret_item_co (_data_);
}

static gboolean
wallet_new_card_dialog_create_secret_item_co (WalletNewCardDialogCreateSecretItemData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = secret_schema_new ("io.elementary.switchboard.wallet", SECRET_SCHEMA_NONE, "brand", SECRET_SCHEMA_ATTRIBUTE_STRING, "exp", SECRET_SCHEMA_ATTRIBUTE_STRING, NULL);
	_data_->schema = _data_->_tmp0_;
	_data_->_tmp1_ = _data_->self->priv->card_number_entry;
	_data_->_tmp2_ = wallet_card_number_entry_get_card_type (_data_->_tmp1_);
	_data_->_tmp3_ = _data_->_tmp2_;
	_data_->_tmp4_ = wallet_card_number_entry_card_type_to_string (_data_->_tmp3_);
	_data_->brand = _data_->_tmp4_;
	_data_->_tmp5_ = g_str_hash;
	_data_->_tmp6_ = g_str_equal;
	_data_->_tmp7_ = g_hash_table_new_full (_data_->_tmp5_, _data_->_tmp6_, _g_free0_, _g_free0_);
	_data_->attributes = _data_->_tmp7_;
	_data_->_tmp8_ = g_strdup ("brand");
	_data_->_tmp9_ = g_strdup (_data_->brand);
	g_hash_table_insert (_data_->attributes, _data_->_tmp8_, _data_->_tmp9_);
	_data_->_tmp10_ = g_strdup ("exp");
	_data_->_tmp11_ = _data_->self->priv->card_expiration_entry;
	_data_->_tmp12_ = gtk_entry_get_text (_data_->_tmp11_);
	_data_->_tmp13_ = _data_->_tmp12_;
	_data_->_tmp14_ = g_strdup (_data_->_tmp13_);
	g_hash_table_insert (_data_->attributes, _data_->_tmp10_, _data_->_tmp14_);
	_data_->_tmp15_ = _data_->self->priv->card_number_entry;
	_data_->_tmp16_ = wallet_card_number_entry_get_card_number (_data_->_tmp15_);
	_data_->_tmp17_ = _data_->_tmp16_;
	_data_->_tmp18_ = _data_->self->priv->card_cvc_entry;
	_data_->_tmp19_ = gtk_entry_get_text (_data_->_tmp18_);
	_data_->_tmp20_ = _data_->_tmp19_;
	_data_->_tmp21_ = g_strdup_printf ("\n" \
"          {\n" \
"            \"card\": {\n" \
"              \"number\": %s,\n" \
"              \"cvc\" %s\n" \
"            }\n" \
"          }\n" \
"        ", _data_->_tmp17_, _data_->_tmp20_);
	_data_->secret = _data_->_tmp21_;
	_data_->_tmp22_ = secret_value_new (_data_->secret, (gssize) -1, "text/json");
	_data_->secret_value = _data_->_tmp22_;
	_data_->_tmp23_ = _data_->self->priv->card_number_entry;
	_data_->_tmp24_ = wallet_card_number_entry_get_card_number (_data_->_tmp23_);
	_data_->_tmp25_ = _data_->_tmp24_;
	_data_->_tmp26_ = _data_->self->priv->card_number_entry;
	_data_->_tmp27_ = wallet_card_number_entry_get_card_number (_data_->_tmp26_);
	_data_->_tmp28_ = _data_->_tmp27_;
	_data_->_tmp29_ = strlen (_data_->_tmp28_);
	_data_->_tmp30_ = _data_->_tmp29_;
	_data_->_tmp31_ = string_substring (_data_->_tmp25_, (glong) (_data_->_tmp30_ - 4), (glong) 4);
	_data_->last_four = _data_->_tmp31_;
	_data_->_tmp32_ = g_strdup_printf (_ ("%s ending in %s"), _data_->brand, _data_->last_four);
	_data_->label = _data_->_tmp32_;
	{
		_data_->_tmp33_ = _data_->self->priv->_collection;
		_data_->_state_ = 1;
		secret_item_create (_data_->_tmp33_, _data_->schema, _data_->attributes, _data_->label, _data_->secret_value, SECRET_ITEM_CREATE_NONE, NULL, wallet_new_card_dialog_create_secret_item_ready, _data_);
		return FALSE;
		_state_1:
		_data_->_tmp34_ = secret_item_create_finish (_data_->_res_, &_data_->_inner_error0_);
		_data_->_tmp35_ = _data_->_tmp34_;
		_g_object_unref0 (_data_->_tmp35_);
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		_data_->_error_ = _data_->_inner_error0_;
		_data_->_inner_error0_ = NULL;
		_data_->_tmp36_ = _data_->_error_;
		_data_->_tmp37_ = _data_->_tmp36_->message;
		g_critical ("NewCardDialog.vala:188: %s", _data_->_tmp37_);
		_g_error_free0 (_data_->_error_);
	}
	__finally0:
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		_g_free0 (_data_->label);
		_g_free0 (_data_->last_four);
		_secret_value_unref0 (_data_->secret_value);
		_g_free0 (_data_->secret);
		_g_hash_table_unref0 (_data_->attributes);
		_g_free0 (_data_->brand);
		_secret_schema_unref0 (_data_->schema);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
		g_clear_error (&_data_->_inner_error0_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_g_free0 (_data_->label);
	_g_free0 (_data_->last_four);
	_secret_value_unref0 (_data_->secret_value);
	_g_free0 (_data_->secret);
	_g_hash_table_unref0 (_data_->attributes);
	_g_free0 (_data_->brand);
	_secret_schema_unref0 (_data_->schema);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	string_length = (glong) _tmp1_;
	if (start < ((glong) 0)) {
		start = string_length + start;
	}
	if (end < ((glong) 0)) {
		end = string_length + end;
	}
	if (start >= ((glong) 0)) {
		_tmp2_ = start <= string_length;
	} else {
		_tmp2_ = FALSE;
	}
	g_return_val_if_fail (_tmp2_, NULL);
	if (end >= ((glong) 0)) {
		_tmp3_ = end <= string_length;
	} else {
		_tmp3_ = FALSE;
	}
	g_return_val_if_fail (_tmp3_, NULL);
	g_return_val_if_fail (start <= end, NULL);
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
	result = _tmp4_;
	return result;
}

static void
wallet_new_card_dialog_validate_card_number (WalletNewCardDialog* self,
                                             const gchar* numbers)
{
	gint char_count = 0;
	gint hash = 0;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp2_;
	gint j = 0;
	gint sum = 0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (numbers != NULL);
	char_count = g_utf8_strlen (numbers, (gssize) -1);
	if (char_count < 14) {
		self->priv->card_valid = FALSE;
		return;
	}
	_tmp0_ = string_slice (numbers, (glong) (char_count - 1), (glong) char_count);
	_tmp1_ = _tmp0_;
	_tmp2_ = atoi (_tmp1_);
	_g_free0 (_tmp1_);
	hash = _tmp2_;
	j = 1;
	sum = 0;
	{
		gint i = 0;
		i = char_count - 1;
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				gint number = 0;
				gchar* _tmp5_;
				gchar* _tmp6_;
				gint _tmp7_;
				gint _tmp8_;
				if (!_tmp3_) {
					gint _tmp4_;
					_tmp4_ = i;
					i = _tmp4_ - 1;
				}
				_tmp3_ = FALSE;
				if (!(i > 0)) {
					break;
				}
				_tmp5_ = string_slice (numbers, (glong) (i - 1), (glong) i);
				_tmp6_ = _tmp5_;
				_tmp7_ = atoi (_tmp6_);
				_g_free0 (_tmp6_);
				number = _tmp7_;
				_tmp8_ = j;
				j = _tmp8_ + 1;
				if ((_tmp8_ % 2) == 1) {
					number = number * 2;
					if (number > 9) {
						number = number - 9;
					}
				}
				sum += number;
			}
		}
	}
	self->priv->card_valid = ((10 - (sum % 10)) % 10) == hash;
}

static void
wallet_new_card_dialog_validate_expiration (WalletNewCardDialog* self,
                                            const gchar* expiration)
{
	gint _tmp0_;
	gint _tmp1_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (expiration != NULL);
	_tmp0_ = strlen (expiration);
	_tmp1_ = _tmp0_;
	if (_tmp1_ < 4) {
		self->priv->expiration_valid = FALSE;
	} else {
		{
			GRegex* regex = NULL;
			GRegex* _tmp2_;
			GRegex* _tmp3_;
			_tmp2_ = g_regex_new ("^[0-9]{2}\\/?[0-9]{2}$", 0, 0, &_inner_error0_);
			regex = _tmp2_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch0_g_error;
			}
			_tmp3_ = regex;
			self->priv->expiration_valid = g_regex_match (_tmp3_, expiration, 0, NULL);
			_g_regex_unref0 (regex);
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp4_;
			const gchar* _tmp5_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp4_ = e;
			_tmp5_ = _tmp4_->message;
			g_critical ("NewCardDialog.vala:227: %s", _tmp5_);
			self->priv->expiration_valid = FALSE;
			_g_error_free0 (e);
		}
		__finally0:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
}

static void
wallet_new_card_dialog_validate_cvc (WalletNewCardDialog* self,
                                     const gchar* cvc)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (cvc != NULL);
	{
		GRegex* regex = NULL;
		GRegex* _tmp0_;
		_tmp0_ = g_regex_new ("[0-9]{3,4}", 0, 0, &_inner_error0_);
		regex = _tmp0_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		self->priv->cvc_valid = g_regex_match (regex, cvc, 0, NULL);
		_g_regex_unref0 (regex);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp1_ = e;
		_tmp2_ = _tmp1_->message;
		g_critical ("NewCardDialog.vala:238: %s", _tmp2_);
		self->priv->cvc_valid = FALSE;
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static void
wallet_new_card_dialog_validate_form (WalletNewCardDialog* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GtkButton* _tmp2_;
	g_return_if_fail (self != NULL);
	if (self->priv->card_valid) {
		_tmp1_ = self->priv->expiration_valid;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		_tmp0_ = self->priv->cvc_valid;
	} else {
		_tmp0_ = FALSE;
	}
	_tmp2_ = self->priv->pay_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp2_, _tmp0_);
}

SecretCollection*
wallet_new_card_dialog_get_collection (WalletNewCardDialog* self)
{
	SecretCollection* result;
	SecretCollection* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_collection;
	result = _tmp0_;
	return result;
}

static void
wallet_new_card_dialog_set_collection (WalletNewCardDialog* self,
                                       SecretCollection* value)
{
	SecretCollection* old_value;
	g_return_if_fail (self != NULL);
	old_value = wallet_new_card_dialog_get_collection (self);
	if (old_value != value) {
		SecretCollection* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_collection);
		self->priv->_collection = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, wallet_new_card_dialog_properties[WALLET_NEW_CARD_DIALOG_COLLECTION_PROPERTY]);
	}
}

static void
_wallet_new_card_dialog___lambda8_ (WalletNewCardDialog* self,
                                    gint response_id)
{
	if (response_id == ((gint) GTK_RESPONSE_APPLY)) {
		wallet_new_card_dialog_create_secret_item (self, NULL, NULL);
	}
	gtk_widget_destroy ((GtkWidget*) self);
}

static void
__wallet_new_card_dialog___lambda8__gtk_dialog_response (GtkDialog* _sender,
                                                         gint response_id,
                                                         gpointer self)
{
	_wallet_new_card_dialog___lambda8_ ((WalletNewCardDialog*) self, response_id);
}

static void
_wallet_new_card_dialog___lambda9_ (WalletNewCardDialog* self)
{
	WalletCardNumberEntry* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	_tmp0_ = self->priv->card_number_entry;
	_tmp1_ = wallet_card_number_entry_get_card_number (_tmp0_);
	_tmp2_ = _tmp1_;
	wallet_new_card_dialog_validate_card_number (self, _tmp2_);
	wallet_new_card_dialog_validate_form (self);
}

static void
__wallet_new_card_dialog___lambda9__gtk_editable_changed (GtkEditable* _sender,
                                                          gpointer self)
{
	_wallet_new_card_dialog___lambda9_ ((WalletNewCardDialog*) self);
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (*((gchar*) old)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (self);
		result = _tmp2_;
		return result;
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = g_regex_escape_string (old, -1);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		regex = _tmp6_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp8_ = regex;
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		result = _tmp10_;
		_g_free0 (_tmp7_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		g_clear_error (&_inner_error0_);
		g_assert_not_reached ();
	}
	__finally0:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
	g_clear_error (&_inner_error0_);
	return NULL;
}

static void
_wallet_new_card_dialog___lambda10_ (WalletNewCardDialog* self)
{
	GtkEntry* _tmp0_;
	GtkEntry* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GtkEntry* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	_tmp0_ = self->priv->card_expiration_entry;
	_tmp1_ = self->priv->card_expiration_entry;
	_tmp2_ = gtk_entry_get_text (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = string_replace (_tmp3_, " ", "");
	_tmp5_ = _tmp4_;
	gtk_entry_set_text (_tmp0_, _tmp5_);
	_g_free0 (_tmp5_);
	_tmp6_ = self->priv->card_expiration_entry;
	_tmp7_ = gtk_entry_get_text (_tmp6_);
	_tmp8_ = _tmp7_;
	wallet_new_card_dialog_validate_expiration (self, _tmp8_);
	wallet_new_card_dialog_validate_form (self);
}

static void
__wallet_new_card_dialog___lambda10__gtk_editable_changed (GtkEditable* _sender,
                                                           gpointer self)
{
	_wallet_new_card_dialog___lambda10_ ((WalletNewCardDialog*) self);
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}

static gboolean
_wallet_new_card_dialog___lambda11_ (WalletNewCardDialog* self)
{
	gchar* expiration_text = NULL;
	GtkEntry* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gboolean _tmp4_ = FALSE;
	const gchar* _tmp5_;
	_tmp0_ = self->priv->card_expiration_entry;
	_tmp1_ = gtk_entry_get_text (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_strdup (_tmp2_);
	expiration_text = _tmp3_;
	_tmp5_ = expiration_text;
	if (!string_contains (_tmp5_, "/")) {
		const gchar* _tmp6_;
		_tmp6_ = expiration_text;
		_tmp4_ = g_utf8_strlen (_tmp6_, (gssize) -1) > 2;
	} else {
		_tmp4_ = FALSE;
	}
	if (_tmp4_) {
		gint position = 0;
		GtkEntry* _tmp7_;
		position = 2;
		_tmp7_ = self->priv->card_expiration_entry;
		g_signal_emit_by_name ((GtkEditable*) _tmp7_, "insert-text", "/", 1, &position);
	}
	_g_free0 (expiration_text);
}

static gboolean
__wallet_new_card_dialog___lambda11__gtk_widget_focus_out_event (GtkWidget* _sender,
                                                                 GdkEventFocus* event,
                                                                 gpointer self)
{
	gboolean result;
	result = _wallet_new_card_dialog___lambda11_ ((WalletNewCardDialog*) self);
	return result;
}

static void
_wallet_new_card_dialog___lambda12_ (WalletNewCardDialog* self)
{
	GtkEntry* _tmp0_;
	GtkEntry* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GtkEntry* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	_tmp0_ = self->priv->card_cvc_entry;
	_tmp1_ = self->priv->card_cvc_entry;
	_tmp2_ = gtk_entry_get_text (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = string_replace (_tmp3_, " ", "");
	_tmp5_ = _tmp4_;
	gtk_entry_set_text (_tmp0_, _tmp5_);
	_g_free0 (_tmp5_);
	_tmp6_ = self->priv->card_cvc_entry;
	_tmp7_ = gtk_entry_get_text (_tmp6_);
	_tmp8_ = _tmp7_;
	wallet_new_card_dialog_validate_cvc (self, _tmp8_);
	wallet_new_card_dialog_validate_form (self);
}

static void
__wallet_new_card_dialog___lambda12__gtk_editable_changed (GtkEditable* _sender,
                                                           gpointer self)
{
	_wallet_new_card_dialog___lambda12_ ((WalletNewCardDialog*) self);
}

static GObject *
wallet_new_card_dialog_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	WalletNewCardDialog * self;
	GtkImage* image = NULL;
	GtkImage* _tmp0_;
	GtkImage* _tmp1_;
	GtkLabel* primary_label = NULL;
	GtkLabel* _tmp2_;
	GtkLabel* _tmp3_;
	GtkStyleContext* _tmp4_;
	GtkLabel* _tmp5_;
	GtkLabel* secondary_label = NULL;
	GtkLabel* _tmp6_;
	GtkLabel* _tmp7_;
	GtkLabel* _tmp8_;
	GtkLabel* _tmp9_;
	GtkLabel* _tmp10_;
	WalletCardNumberEntry* _tmp11_;
	WalletCardNumberEntry* _tmp12_;
	WalletCardNumberEntry* _tmp13_;
	WalletCardNumberEntry* _tmp14_;
	WalletCardNumberEntry* _tmp15_;
	GtkEntry* _tmp16_;
	GtkEntry* _tmp17_;
	GtkEntry* _tmp18_;
	GtkEntry* _tmp19_;
	GtkEntry* _tmp20_;
	GtkEntry* _tmp21_;
	GtkEntry* _tmp22_;
	GtkEntry* _tmp23_;
	GtkEntry* _tmp24_;
	GtkEntry* _tmp25_;
	GtkEntry* _tmp26_;
	GtkEntry* _tmp27_;
	GtkEntry* _tmp28_;
	GtkEntry* _tmp29_;
	GtkEntry* _tmp30_;
	GtkGrid* card_grid_bottom = NULL;
	GtkGrid* _tmp31_;
	GtkGrid* _tmp32_;
	GtkStyleContext* _tmp33_;
	GtkGrid* _tmp34_;
	GtkEntry* _tmp35_;
	GtkGrid* _tmp36_;
	GtkEntry* _tmp37_;
	GtkGrid* card_grid = NULL;
	GtkGrid* _tmp38_;
	GtkGrid* _tmp39_;
	GtkStyleContext* _tmp40_;
	GtkGrid* _tmp41_;
	GtkGrid* _tmp42_;
	WalletCardNumberEntry* _tmp43_;
	GtkGrid* _tmp44_;
	GtkGrid* _tmp45_;
	GtkGrid* card_layout = NULL;
	GtkGrid* _tmp46_;
	GtkGrid* _tmp47_;
	GtkStyleContext* _tmp48_;
	GtkGrid* _tmp49_;
	GtkGrid* _tmp50_;
	GtkGrid* _tmp51_;
	GtkGrid* _tmp52_;
	GtkGrid* _tmp53_;
	GtkImage* _tmp54_;
	GtkGrid* _tmp55_;
	GtkLabel* _tmp56_;
	GtkGrid* _tmp57_;
	GtkLabel* _tmp58_;
	GtkGrid* _tmp59_;
	GtkGrid* _tmp60_;
	GtkGrid* _tmp61_;
	GtkBox* _tmp62_;
	GtkGrid* _tmp63_;
	GtkBox* _tmp64_;
	GtkWidget* _tmp65_;
	GtkButton* _tmp66_;
	GtkButton* _tmp67_;
	GtkStyleContext* _tmp68_;
	GtkButton* _tmp69_;
	GtkButton* _tmp70_;
	WalletCardNumberEntry* _tmp71_;
	GtkEntry* _tmp72_;
	GtkEntry* _tmp73_;
	GtkEntry* _tmp74_;
	parent_class = G_OBJECT_CLASS (wallet_new_card_dialog_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WALLET_TYPE_NEW_CARD_DIALOG, WalletNewCardDialog);
	_tmp0_ = (GtkImage*) gtk_image_new_from_icon_name ("payment-card", (GtkIconSize) GTK_ICON_SIZE_DIALOG);
	g_object_ref_sink (_tmp0_);
	image = _tmp0_;
	_tmp1_ = image;
	gtk_widget_set_valign ((GtkWidget*) _tmp1_, GTK_ALIGN_START);
	_tmp2_ = (GtkLabel*) gtk_label_new (_ ("Add a new card"));
	g_object_ref_sink (_tmp2_);
	primary_label = _tmp2_;
	_tmp3_ = primary_label;
	_tmp4_ = gtk_widget_get_style_context ((GtkWidget*) _tmp3_);
	gtk_style_context_add_class (_tmp4_, GRANITE_STYLE_CLASS_PRIMARY_LABEL);
	_tmp5_ = primary_label;
	gtk_label_set_xalign (_tmp5_, (gfloat) 0);
	_tmp6_ = (GtkLabel*) gtk_label_new (_ ("Card information is stored encrypted, on your device."));
	g_object_ref_sink (_tmp6_);
	secondary_label = _tmp6_;
	_tmp7_ = secondary_label;
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp7_, 18);
	_tmp8_ = secondary_label;
	gtk_label_set_max_width_chars (_tmp8_, 50);
	_tmp9_ = secondary_label;
	g_object_set (_tmp9_, "wrap", TRUE, NULL);
	_tmp10_ = secondary_label;
	gtk_label_set_xalign (_tmp10_, (gfloat) 0);
	_tmp11_ = wallet_card_number_entry_new ();
	g_object_ref_sink (_tmp11_);
	_g_object_unref0 (self->priv->card_number_entry);
	self->priv->card_number_entry = _tmp11_;
	_tmp12_ = self->priv->card_number_entry;
	gtk_entry_set_activates_default ((GtkEntry*) _tmp12_, TRUE);
	_tmp13_ = self->priv->card_number_entry;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp13_, TRUE);
	_tmp14_ = self->priv->card_number_entry;
	_tmp15_ = self->priv->card_number_entry;
	g_object_bind_property_with_closures ((GObject*) _tmp14_, "has-focus", (GObject*) _tmp15_, "visibility", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp16_ = (GtkEntry*) gtk_entry_new ();
	g_object_ref_sink (_tmp16_);
	_g_object_unref0 (self->priv->card_expiration_entry);
	self->priv->card_expiration_entry = _tmp16_;
	_tmp17_ = self->priv->card_expiration_entry;
	gtk_entry_set_activates_default (_tmp17_, TRUE);
	_tmp18_ = self->priv->card_expiration_entry;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp18_, TRUE);
	_tmp19_ = self->priv->card_expiration_entry;
	gtk_entry_set_max_length (_tmp19_, 5);
	_tmp20_ = self->priv->card_expiration_entry;
	gtk_entry_set_placeholder_text (_tmp20_, _ ("MM / YY"));
	_tmp21_ = self->priv->card_expiration_entry;
	g_object_set (_tmp21_, "primary-icon-name", "office-calendar-symbolic", NULL);
	_tmp22_ = (GtkEntry*) gtk_entry_new ();
	g_object_ref_sink (_tmp22_);
	_g_object_unref0 (self->priv->card_cvc_entry);
	self->priv->card_cvc_entry = _tmp22_;
	_tmp23_ = self->priv->card_cvc_entry;
	gtk_entry_set_activates_default (_tmp23_, TRUE);
	_tmp24_ = self->priv->card_cvc_entry;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp24_, TRUE);
	_tmp25_ = self->priv->card_cvc_entry;
	gtk_entry_set_input_purpose (_tmp25_, GTK_INPUT_PURPOSE_DIGITS);
	_tmp26_ = self->priv->card_cvc_entry;
	gtk_entry_set_max_length (_tmp26_, 4);
	_tmp27_ = self->priv->card_cvc_entry;
	gtk_entry_set_placeholder_text (_tmp27_, _ ("CVC"));
	_tmp28_ = self->priv->card_cvc_entry;
	g_object_set (_tmp28_, "primary-icon-name", "channel-secure-symbolic", NULL);
	_tmp29_ = self->priv->card_cvc_entry;
	_tmp30_ = self->priv->card_cvc_entry;
	g_object_bind_property_with_closures ((GObject*) _tmp29_, "has-focus", (GObject*) _tmp30_, "visibility", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp31_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp31_);
	card_grid_bottom = _tmp31_;
	_tmp32_ = card_grid_bottom;
	_tmp33_ = gtk_widget_get_style_context ((GtkWidget*) _tmp32_);
	gtk_style_context_add_class (_tmp33_, GTK_STYLE_CLASS_LINKED);
	_tmp34_ = card_grid_bottom;
	_tmp35_ = self->priv->card_expiration_entry;
	gtk_container_add ((GtkContainer*) _tmp34_, (GtkWidget*) _tmp35_);
	_tmp36_ = card_grid_bottom;
	_tmp37_ = self->priv->card_cvc_entry;
	gtk_container_add ((GtkContainer*) _tmp36_, (GtkWidget*) _tmp37_);
	_tmp38_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp38_);
	card_grid = _tmp38_;
	_tmp39_ = card_grid;
	_tmp40_ = gtk_widget_get_style_context ((GtkWidget*) _tmp39_);
	gtk_style_context_add_class (_tmp40_, GTK_STYLE_CLASS_LINKED);
	_tmp41_ = card_grid;
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp41_, GTK_ORIENTATION_VERTICAL);
	_tmp42_ = card_grid;
	_tmp43_ = self->priv->card_number_entry;
	gtk_container_add ((GtkContainer*) _tmp42_, (GtkWidget*) _tmp43_);
	_tmp44_ = card_grid;
	_tmp45_ = card_grid_bottom;
	gtk_container_add ((GtkContainer*) _tmp44_, (GtkWidget*) _tmp45_);
	_tmp46_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp46_);
	card_layout = _tmp46_;
	_tmp47_ = card_layout;
	_tmp48_ = gtk_widget_get_style_context ((GtkWidget*) _tmp47_);
	gtk_style_context_add_class (_tmp48_, "login");
	_tmp49_ = card_layout;
	gtk_grid_set_column_spacing (_tmp49_, 12);
	_tmp50_ = card_layout;
	gtk_grid_set_row_spacing (_tmp50_, 6);
	_tmp51_ = card_layout;
	g_object_set ((GtkWidget*) _tmp51_, "margin", 10, NULL);
	_tmp52_ = card_layout;
	gtk_widget_set_margin_top ((GtkWidget*) _tmp52_, 0);
	_tmp53_ = card_layout;
	_tmp54_ = image;
	gtk_grid_attach (_tmp53_, (GtkWidget*) _tmp54_, 0, 0, 1, 2);
	_tmp55_ = card_layout;
	_tmp56_ = primary_label;
	gtk_grid_attach (_tmp55_, (GtkWidget*) _tmp56_, 1, 0, 1, 1);
	_tmp57_ = card_layout;
	_tmp58_ = secondary_label;
	gtk_grid_attach (_tmp57_, (GtkWidget*) _tmp58_, 1, 1, 1, 1);
	_tmp59_ = card_layout;
	_tmp60_ = card_grid;
	gtk_grid_attach (_tmp59_, (GtkWidget*) _tmp60_, 1, 2, 1, 1);
	_tmp61_ = card_layout;
	gtk_widget_show_all ((GtkWidget*) _tmp61_);
	_tmp62_ = gtk_dialog_get_content_area ((GtkDialog*) self);
	_tmp63_ = card_layout;
	gtk_container_add ((GtkContainer*) _tmp62_, (GtkWidget*) _tmp63_);
	_tmp64_ = gtk_dialog_get_action_area ((GtkDialog*) self);
	g_object_set ((GtkWidget*) _tmp64_, "margin", 5, NULL);
	gtk_dialog_add_button ((GtkDialog*) self, _ ("Cancel"), (gint) GTK_RESPONSE_CLOSE);
	_tmp65_ = gtk_dialog_add_button ((GtkDialog*) self, _ ("Add Card"), (gint) GTK_RESPONSE_APPLY);
	_tmp66_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp65_, gtk_button_get_type (), GtkButton));
	_g_object_unref0 (self->priv->pay_button);
	self->priv->pay_button = _tmp66_;
	_tmp67_ = self->priv->pay_button;
	_tmp68_ = gtk_widget_get_style_context ((GtkWidget*) _tmp67_);
	gtk_style_context_add_class (_tmp68_, GTK_STYLE_CLASS_SUGGESTED_ACTION);
	_tmp69_ = self->priv->pay_button;
	g_object_set ((GtkWidget*) _tmp69_, "has-default", TRUE, NULL);
	_tmp70_ = self->priv->pay_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp70_, FALSE);
	gtk_window_set_deletable ((GtkWindow*) self, FALSE);
	gtk_window_set_resizable ((GtkWindow*) self, FALSE);
	g_signal_connect_object ((GtkDialog*) self, "response", (GCallback) __wallet_new_card_dialog___lambda8__gtk_dialog_response, self, 0);
	_tmp71_ = self->priv->card_number_entry;
	g_signal_connect_object ((GtkEditable*) _tmp71_, "changed", (GCallback) __wallet_new_card_dialog___lambda9__gtk_editable_changed, self, 0);
	_tmp72_ = self->priv->card_expiration_entry;
	g_signal_connect_object ((GtkEditable*) _tmp72_, "changed", (GCallback) __wallet_new_card_dialog___lambda10__gtk_editable_changed, self, 0);
	_tmp73_ = self->priv->card_expiration_entry;
	g_signal_connect_object ((GtkWidget*) _tmp73_, "focus-out-event", (GCallback) __wallet_new_card_dialog___lambda11__gtk_widget_focus_out_event, self, 0);
	_tmp74_ = self->priv->card_cvc_entry;
	g_signal_connect_object ((GtkEditable*) _tmp74_, "changed", (GCallback) __wallet_new_card_dialog___lambda12__gtk_editable_changed, self, 0);
	_g_object_unref0 (card_layout);
	_g_object_unref0 (card_grid);
	_g_object_unref0 (card_grid_bottom);
	_g_object_unref0 (secondary_label);
	_g_object_unref0 (primary_label);
	_g_object_unref0 (image);
	return obj;
}

static void
wallet_new_card_dialog_class_init (WalletNewCardDialogClass * klass,
                                   gpointer klass_data)
{
	wallet_new_card_dialog_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &WalletNewCardDialog_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_wallet_new_card_dialog_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_wallet_new_card_dialog_set_property;
	G_OBJECT_CLASS (klass)->constructor = wallet_new_card_dialog_constructor;
	G_OBJECT_CLASS (klass)->finalize = wallet_new_card_dialog_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), WALLET_NEW_CARD_DIALOG_COLLECTION_PROPERTY, wallet_new_card_dialog_properties[WALLET_NEW_CARD_DIALOG_COLLECTION_PROPERTY] = g_param_spec_object ("collection", "collection", "collection", secret_collection_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}

static void
wallet_new_card_dialog_instance_init (WalletNewCardDialog * self,
                                      gpointer klass)
{
	self->priv = wallet_new_card_dialog_get_instance_private (self);
	self->priv->card_valid = FALSE;
	self->priv->expiration_valid = FALSE;
	self->priv->cvc_valid = FALSE;
}

static void
wallet_new_card_dialog_finalize (GObject * obj)
{
	WalletNewCardDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WALLET_TYPE_NEW_CARD_DIALOG, WalletNewCardDialog);
	_g_object_unref0 (self->priv->_collection);
	_g_object_unref0 (self->priv->pay_button);
	_g_object_unref0 (self->priv->card_expiration_entry);
	_g_object_unref0 (self->priv->card_cvc_entry);
	_g_object_unref0 (self->priv->card_number_entry);
	G_OBJECT_CLASS (wallet_new_card_dialog_parent_class)->finalize (obj);
}

static GType
wallet_new_card_dialog_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WalletNewCardDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) wallet_new_card_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WalletNewCardDialog), 0, (GInstanceInitFunc) wallet_new_card_dialog_instance_init, NULL };
	GType wallet_new_card_dialog_type_id;
	wallet_new_card_dialog_type_id = g_type_register_static (gtk_dialog_get_type (), "WalletNewCardDialog", &g_define_type_info, 0);
	WalletNewCardDialog_private_offset = g_type_add_instance_private (wallet_new_card_dialog_type_id, sizeof (WalletNewCardDialogPrivate));
	return wallet_new_card_dialog_type_id;
}

GType
wallet_new_card_dialog_get_type (void)
{
	static volatile gsize wallet_new_card_dialog_type_id__once = 0;
	if (g_once_init_enter (&wallet_new_card_dialog_type_id__once)) {
		GType wallet_new_card_dialog_type_id;
		wallet_new_card_dialog_type_id = wallet_new_card_dialog_get_type_once ();
		g_once_init_leave (&wallet_new_card_dialog_type_id__once, wallet_new_card_dialog_type_id);
	}
	return wallet_new_card_dialog_type_id__once;
}

static void
_vala_wallet_new_card_dialog_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	WalletNewCardDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WALLET_TYPE_NEW_CARD_DIALOG, WalletNewCardDialog);
	switch (property_id) {
		case WALLET_NEW_CARD_DIALOG_COLLECTION_PROPERTY:
		g_value_set_object (value, wallet_new_card_dialog_get_collection (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_wallet_new_card_dialog_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	WalletNewCardDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WALLET_TYPE_NEW_CARD_DIALOG, WalletNewCardDialog);
	switch (property_id) {
		case WALLET_NEW_CARD_DIALOG_COLLECTION_PROPERTY:
		wallet_new_card_dialog_set_collection (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

