/* CardNumberEntry.c generated by valac 0.56.12, the Vala compiler
 * generated from CardNumberEntry.vala, do not modify */

/*-
 * Copyright 2018-2020 elementary, Inc. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include "io.elementary.switchboard.wallet.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>

enum  {
	WALLET_CARD_NUMBER_ENTRY_0_PROPERTY,
	WALLET_CARD_NUMBER_ENTRY_CARD_NUMBER_PROPERTY,
	WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_PROPERTY,
	WALLET_CARD_NUMBER_ENTRY_NUM_PROPERTIES
};
static GParamSpec* wallet_card_number_entry_properties[WALLET_CARD_NUMBER_ENTRY_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block1Data Block1Data;
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

struct _WalletCardNumberEntryPrivate {
	gchar* _card_number;
	WalletCardNumberEntryCardType _card_type;
	guint timeout;
	gboolean insertion;
};

struct _Block1Data {
	int _ref_count_;
	WalletCardNumberEntry* self;
	gint end_offset;
	gint new_offset;
};

static gint WalletCardNumberEntry_private_offset;
static gpointer wallet_card_number_entry_parent_class = NULL;

static void wallet_card_number_entry_update_number (WalletCardNumberEntry* self);
static void wallet_card_number_entry_detect_card (WalletCardNumberEntry* self);
static void wallet_card_number_entry_set_card_type (WalletCardNumberEntry* self,
                                             WalletCardNumberEntryCardType value);
static void wallet_card_number_entry_change_card_icon (WalletCardNumberEntry* self);
static gint* wallet_card_number_entry_get_card_pattern (WalletCardNumberEntry* self,
                                                 gint* result_length1);
static gint wallet_card_number_entry_get_card_max_length (WalletCardNumberEntry* self);
static GObject * wallet_card_number_entry_constructor (GType type,
                                                guint n_construct_properties,
                                                GObjectConstructParam * construct_properties);
static void _wallet_card_number_entry___lambda4_ (WalletCardNumberEntry* self,
                                           gint start_pos,
                                           gint end_pos);
static void __wallet_card_number_entry___lambda4__gtk_editable_delete_text (GtkEditable* _sender,
                                                                     gint start_pos,
                                                                     gint end_pos,
                                                                     gpointer self);
static void _wallet_card_number_entry___lambda5_ (WalletCardNumberEntry* self,
                                           const gchar* start_pos,
                                           gint end_pos,
                                           gint* pos);
static void __wallet_card_number_entry___lambda5__gtk_editable_insert_text (GtkEditable* _sender,
                                                                     const gchar* new_text,
                                                                     gint new_text_length,
                                                                     gint* position,
                                                                     gpointer self);
static void _wallet_card_number_entry___lambda6_ (WalletCardNumberEntry* self);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static gboolean _vala_int_array_contains (gint * stack,
                                   gssize stack_length,
                                   const gint needle);
static gboolean ___lambda7_ (Block1Data* _data1_);
static gboolean ____lambda7__gsource_func (gpointer self);
static void __wallet_card_number_entry___lambda6__gtk_editable_changed (GtkEditable* _sender,
                                                                 gpointer self);
static void wallet_card_number_entry_finalize (GObject * obj);
static GType wallet_card_number_entry_get_type_once (void);
static void _vala_wallet_card_number_entry_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec);
static void _vala_wallet_card_number_entry_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec);

static inline gpointer
wallet_card_number_entry_get_instance_private (WalletCardNumberEntry* self)
{
	return G_STRUCT_MEMBER_P (self, WalletCardNumberEntry_private_offset);
}

gchar*
wallet_card_number_entry_card_type_to_string (WalletCardNumberEntryCardType self)
{
	gchar* result;
	switch (self) {
		case WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_VISA:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup ("Visa");
			result = _tmp0_;
			return result;
		}
		case WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_MASTERCARD:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup ("MasterCard");
			result = _tmp1_;
			return result;
		}
		case WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_AMERICAN_EXPRESS:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup ("American Express");
			result = _tmp2_;
			return result;
		}
		case WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_DISCOVER:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup ("Discover");
			result = _tmp3_;
			return result;
		}
		case WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_DINERS_CLUB:
		{
			gchar* _tmp4_;
			_tmp4_ = g_strdup ("Diners Club");
			result = _tmp4_;
			return result;
		}
		case WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_JCB:
		{
			gchar* _tmp5_;
			_tmp5_ = g_strdup ("JCB");
			result = _tmp5_;
			return result;
		}
		case WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_UNIONPAY:
		{
			gchar* _tmp6_;
			_tmp6_ = g_strdup ("UnionPay");
			result = _tmp6_;
			return result;
		}
		default:
		{
			gchar* _tmp7_;
			_tmp7_ = g_strdup ("Unknown");
			result = _tmp7_;
			return result;
		}
	}
}

static GType
wallet_card_number_entry_card_type_get_type_once (void)
{
	static const GEnumValue values[] = {{WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_UNKNOWN, "WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_UNKNOWN", "unknown"}, {WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_VISA, "WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_VISA", "visa"}, {WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_MASTERCARD, "WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_MASTERCARD", "mastercard"}, {WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_AMERICAN_EXPRESS, "WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_AMERICAN_EXPRESS", "american-express"}, {WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_DISCOVER, "WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_DISCOVER", "discover"}, {WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_DINERS_CLUB, "WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_DINERS_CLUB", "diners-club"}, {WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_JCB, "WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_JCB", "jcb"}, {WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_UNIONPAY, "WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_UNIONPAY", "unionpay"}, {0, NULL, NULL}};
	GType wallet_card_number_entry_card_type_type_id;
	wallet_card_number_entry_card_type_type_id = g_enum_register_static ("WalletCardNumberEntryCardType", values);
	return wallet_card_number_entry_card_type_type_id;
}

GType
wallet_card_number_entry_card_type_get_type (void)
{
	static volatile gsize wallet_card_number_entry_card_type_type_id__once = 0;
	if (g_once_init_enter (&wallet_card_number_entry_card_type_type_id__once)) {
		GType wallet_card_number_entry_card_type_type_id;
		wallet_card_number_entry_card_type_type_id = wallet_card_number_entry_card_type_get_type_once ();
		g_once_init_leave (&wallet_card_number_entry_card_type_type_id__once, wallet_card_number_entry_card_type_type_id);
	}
	return wallet_card_number_entry_card_type_type_id__once;
}

static void
wallet_card_number_entry_update_number (WalletCardNumberEntry* self)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	{
		GRegex* regex = NULL;
		GRegex* _tmp0_;
		gchar* _tmp1_ = NULL;
		GRegex* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		_tmp0_ = g_regex_new ("[^0-9]", 0, 0, &_inner_error0_);
		regex = _tmp0_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp2_ = regex;
		_tmp3_ = gtk_entry_get_text ((GtkEntry*) self);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_regex_replace_literal (_tmp2_, _tmp4_, (gssize) -1, 0, "", 0, &_inner_error0_);
		_tmp1_ = _tmp5_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_regex_unref0 (regex);
			goto __catch0_g_error;
		}
		wallet_card_number_entry_set_card_number (self, _tmp1_);
		_g_free0 (_tmp1_);
		_g_regex_unref0 (regex);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp6_ = e;
		_tmp7_ = _tmp6_->message;
		g_critical ("CardNumberEntry.vala:108: %s", _tmp7_);
		_tmp8_ = gtk_entry_get_text ((GtkEntry*) self);
		_tmp9_ = _tmp8_;
		wallet_card_number_entry_set_card_number (self, _tmp9_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static void
wallet_card_number_entry_detect_card (WalletCardNumberEntry* self)
{
	gchar* number = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gboolean _tmp4_ = FALSE;
	const gchar* _tmp5_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_card_number;
	_tmp1_ = g_strdup (_tmp0_);
	number = _tmp1_;
	_tmp2_ = number;
	if (g_str_has_prefix (_tmp2_, "4")) {
		wallet_card_number_entry_set_card_type (self, WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_VISA);
		_g_free0 (number);
		return;
	}
	_tmp3_ = number;
	if (g_regex_match_simple ("^(?:5[1-5]|222[1-9]|22[3-9]|2[3-6]|27[01]|2720)", _tmp3_, 0, 0)) {
		wallet_card_number_entry_set_card_type (self, WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_MASTERCARD);
		_g_free0 (number);
		return;
	}
	_tmp5_ = number;
	if (g_str_has_prefix (_tmp5_, "34")) {
		_tmp4_ = TRUE;
	} else {
		const gchar* _tmp6_;
		_tmp6_ = number;
		_tmp4_ = g_str_has_prefix (_tmp6_, "37");
	}
	if (_tmp4_) {
		wallet_card_number_entry_set_card_type (self, WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_AMERICAN_EXPRESS);
		_g_free0 (number);
		return;
	}
	_tmp7_ = number;
	if (g_str_has_prefix (_tmp7_, "62")) {
		wallet_card_number_entry_set_card_type (self, WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_UNIONPAY);
		_g_free0 (number);
		return;
	}
	_tmp8_ = number;
	if (g_regex_match_simple ("^(2[01]([2-4]|1[4-9])|36|30([0-5]|95)|3[89])", _tmp8_, 0, 0)) {
		wallet_card_number_entry_set_card_type (self, WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_DINERS_CLUB);
		_g_free0 (number);
		return;
	}
	_tmp9_ = number;
	if (g_regex_match_simple ("^(6011|6[45])", _tmp9_, 0, 0)) {
		wallet_card_number_entry_set_card_type (self, WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_DISCOVER);
		_g_free0 (number);
		return;
	}
	_tmp10_ = number;
	if (g_regex_match_simple ("^(35([3-8]|2[89]))", _tmp10_, 0, 0)) {
		wallet_card_number_entry_set_card_type (self, WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_JCB);
		_g_free0 (number);
		return;
	}
	wallet_card_number_entry_set_card_type (self, WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_UNKNOWN);
	_g_free0 (number);
}

static void
wallet_card_number_entry_change_card_icon (WalletCardNumberEntry* self)
{
	WalletCardNumberEntryCardType _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_card_type;
	switch (_tmp0_) {
		case WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_VISA:
		{
			GThemedIcon* _tmp1_;
			GThemedIcon* _tmp2_;
			_tmp1_ = (GThemedIcon*) g_themed_icon_new_with_default_fallbacks ("payment-card-visa");
			_tmp2_ = _tmp1_;
			g_object_set ((GtkEntry*) self, "secondary-icon-gicon", (GIcon*) _tmp2_, NULL);
			_g_object_unref0 (_tmp2_);
			break;
		}
		case WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_MASTERCARD:
		{
			GThemedIcon* _tmp3_;
			GThemedIcon* _tmp4_;
			_tmp3_ = (GThemedIcon*) g_themed_icon_new_with_default_fallbacks ("payment-card-mastercard");
			_tmp4_ = _tmp3_;
			g_object_set ((GtkEntry*) self, "secondary-icon-gicon", (GIcon*) _tmp4_, NULL);
			_g_object_unref0 (_tmp4_);
			break;
		}
		case WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_AMERICAN_EXPRESS:
		{
			GThemedIcon* _tmp5_;
			GThemedIcon* _tmp6_;
			_tmp5_ = (GThemedIcon*) g_themed_icon_new_with_default_fallbacks ("payment-card-amex");
			_tmp6_ = _tmp5_;
			g_object_set ((GtkEntry*) self, "secondary-icon-gicon", (GIcon*) _tmp6_, NULL);
			_g_object_unref0 (_tmp6_);
			break;
		}
		case WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_DISCOVER:
		{
			GThemedIcon* _tmp7_;
			GThemedIcon* _tmp8_;
			_tmp7_ = (GThemedIcon*) g_themed_icon_new_with_default_fallbacks ("payment-card-discover");
			_tmp8_ = _tmp7_;
			g_object_set ((GtkEntry*) self, "secondary-icon-gicon", (GIcon*) _tmp8_, NULL);
			_g_object_unref0 (_tmp8_);
			break;
		}
		case WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_DINERS_CLUB:
		{
			GThemedIcon* _tmp9_;
			GThemedIcon* _tmp10_;
			_tmp9_ = (GThemedIcon*) g_themed_icon_new_with_default_fallbacks ("payment-card-diners-club");
			_tmp10_ = _tmp9_;
			g_object_set ((GtkEntry*) self, "secondary-icon-gicon", (GIcon*) _tmp10_, NULL);
			_g_object_unref0 (_tmp10_);
			break;
		}
		case WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_JCB:
		{
			GThemedIcon* _tmp11_;
			GThemedIcon* _tmp12_;
			_tmp11_ = (GThemedIcon*) g_themed_icon_new_with_default_fallbacks ("payment-card-jcb");
			_tmp12_ = _tmp11_;
			g_object_set ((GtkEntry*) self, "secondary-icon-gicon", (GIcon*) _tmp12_, NULL);
			_g_object_unref0 (_tmp12_);
			break;
		}
		case WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_UNIONPAY:
		{
			GThemedIcon* _tmp13_;
			GThemedIcon* _tmp14_;
			_tmp13_ = (GThemedIcon*) g_themed_icon_new_with_default_fallbacks ("payment-card-unionpay");
			_tmp14_ = _tmp13_;
			g_object_set ((GtkEntry*) self, "secondary-icon-gicon", (GIcon*) _tmp14_, NULL);
			_g_object_unref0 (_tmp14_);
			break;
		}
		default:
		{
			g_object_set ((GtkEntry*) self, "secondary-icon-gicon", NULL, NULL);
			break;
		}
	}
}

static gint*
wallet_card_number_entry_get_card_pattern (WalletCardNumberEntry* self,
                                           gint* result_length1)
{
	WalletCardNumberEntryCardType _tmp0_;
	gint* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_card_type;
	switch (_tmp0_) {
		case WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_AMERICAN_EXPRESS:
		case WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_DINERS_CLUB:
		{
			gint* _tmp1_;
			gint* _tmp2_;
			gint _tmp2__length1;
			_tmp1_ = g_new0 (gint, 2);
			_tmp1_[0] = 4;
			_tmp1_[1] = 10;
			_tmp2_ = _tmp1_;
			_tmp2__length1 = 2;
			if (result_length1) {
				*result_length1 = _tmp2__length1;
			}
			result = _tmp2_;
			return result;
		}
		default:
		case WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_VISA:
		case WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_MASTERCARD:
		case WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_DISCOVER:
		case WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_JCB:
		case WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_UNIONPAY:
		{
			gint* _tmp3_;
			gint* _tmp4_;
			gint _tmp4__length1;
			_tmp3_ = g_new0 (gint, 3);
			_tmp3_[0] = 4;
			_tmp3_[1] = 8;
			_tmp3_[2] = 12;
			_tmp4_ = _tmp3_;
			_tmp4__length1 = 3;
			if (result_length1) {
				*result_length1 = _tmp4__length1;
			}
			result = _tmp4_;
			return result;
		}
	}
}

static gint
wallet_card_number_entry_get_card_max_length (WalletCardNumberEntry* self)
{
	WalletCardNumberEntryCardType _tmp0_;
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_card_type;
	switch (_tmp0_) {
		case WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_AMERICAN_EXPRESS:
		{
			result = 15;
			return result;
		}
		case WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_MASTERCARD:
		{
			result = 16;
			return result;
		}
		default:
		case WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_VISA:
		case WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_DISCOVER:
		case WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_DINERS_CLUB:
		case WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_JCB:
		case WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_UNIONPAY:
		{
			result = 19;
			return result;
		}
	}
}

WalletCardNumberEntry*
wallet_card_number_entry_construct (GType object_type)
{
	WalletCardNumberEntry * self = NULL;
	self = (WalletCardNumberEntry*) g_object_new (object_type, NULL);
	return self;
}

WalletCardNumberEntry*
wallet_card_number_entry_new (void)
{
	return wallet_card_number_entry_construct (WALLET_TYPE_CARD_NUMBER_ENTRY);
}

const gchar*
wallet_card_number_entry_get_card_number (WalletCardNumberEntry* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_card_number;
	result = _tmp0_;
	return result;
}

void
wallet_card_number_entry_set_card_number (WalletCardNumberEntry* self,
                                          const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = wallet_card_number_entry_get_card_number (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_card_number);
		self->priv->_card_number = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, wallet_card_number_entry_properties[WALLET_CARD_NUMBER_ENTRY_CARD_NUMBER_PROPERTY]);
	}
}

WalletCardNumberEntryCardType
wallet_card_number_entry_get_card_type (WalletCardNumberEntry* self)
{
	WalletCardNumberEntryCardType result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_card_type;
	return result;
}

static void
wallet_card_number_entry_set_card_type (WalletCardNumberEntry* self,
                                        WalletCardNumberEntryCardType value)
{
	WalletCardNumberEntryCardType old_value;
	g_return_if_fail (self != NULL);
	old_value = wallet_card_number_entry_get_card_type (self);
	if (old_value != value) {
		self->priv->_card_type = value;
		g_object_notify_by_pspec ((GObject *) self, wallet_card_number_entry_properties[WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_PROPERTY]);
	}
}

static void
_wallet_card_number_entry___lambda4_ (WalletCardNumberEntry* self,
                                      gint start_pos,
                                      gint end_pos)
{
	self->priv->insertion = FALSE;
}

static void
__wallet_card_number_entry___lambda4__gtk_editable_delete_text (GtkEditable* _sender,
                                                                gint start_pos,
                                                                gint end_pos,
                                                                gpointer self)
{
	_wallet_card_number_entry___lambda4_ ((WalletCardNumberEntry*) self, start_pos, end_pos);
}

static void
_wallet_card_number_entry___lambda5_ (WalletCardNumberEntry* self,
                                      const gchar* start_pos,
                                      gint end_pos,
                                      gint* pos)
{
	g_return_if_fail (start_pos != NULL);
	self->priv->insertion = TRUE;
}

static void
__wallet_card_number_entry___lambda5__gtk_editable_insert_text (GtkEditable* _sender,
                                                                const gchar* new_text,
                                                                gint new_text_length,
                                                                gint* position,
                                                                gpointer self)
{
	_wallet_card_number_entry___lambda5_ ((WalletCardNumberEntry*) self, new_text, new_text_length, position);
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
	g_atomic_int_inc (&_data1_->_ref_count_);
	return _data1_;
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
		WalletCardNumberEntry* self;
		self = _data1_->self;
		_g_object_unref0 (self);
		g_slice_free (Block1Data, _data1_);
	}
}

static gchar*
string_to_utf8 (const gchar* self,
                gint* result_length1)
{
	gint string_length = 0;
	gint _tmp0_;
	gint _tmp1_;
	gchar* _result_ = NULL;
	gchar* _tmp2_;
	gint _result__length1;
	gint __result__size_;
	gint _tmp3_;
	gchar* _tmp4_;
	gint _tmp4__length1;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	string_length = _tmp1_;
	_tmp2_ = g_new0 (gchar, string_length + 1);
	_result_ = _tmp2_;
	_result__length1 = string_length + 1;
	__result__size_ = _result__length1;
	_tmp3_ = _result__length1;
	_result__length1 = _tmp3_ - 1;
	memcpy (_result_, self, (gsize) string_length);
	_tmp4_ = _result_;
	_tmp4__length1 = _result__length1;
	if (result_length1) {
		*result_length1 = _tmp4__length1;
	}
	result = _tmp4_;
	return result;
}

static gboolean
_vala_int_array_contains (gint * stack,
                          gssize stack_length,
                          const gint needle)
{
	gssize i;
	for (i = 0; i < stack_length; i++) {
		if (needle == stack[i]) {
			return TRUE;
		}
	}
	return FALSE;
}

static gboolean
___lambda7_ (Block1Data* _data1_)
{
	WalletCardNumberEntry* self;
	gboolean result;
	self = _data1_->self;
	g_signal_emit_by_name ((GtkEntry*) self, "move-cursor", GTK_MOVEMENT_LOGICAL_POSITIONS, _data1_->new_offset - _data1_->end_offset, FALSE);
	result = FALSE;
	return result;
}

static gboolean
____lambda7__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda7_ (self);
	return result;
}

static void
_wallet_card_number_entry___lambda6_ (WalletCardNumberEntry* self)
{
	Block1Data* _data1_;
	gint* pattern = NULL;
	gint _tmp0_ = 0;
	gint* _tmp1_;
	gint pattern_length1;
	gint _pattern_size_;
	gchar* number_chars = NULL;
	const gchar* _tmp2_;
	gint _tmp3_ = 0;
	gchar* _tmp4_;
	gint number_chars_length1;
	gint _number_chars_size_;
	GString* builder = NULL;
	GString* _tmp5_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	gint _tmp19_;
	gint _tmp20_;
	GString* _tmp21_;
	const gchar* _tmp22_;
	const gchar* _tmp23_;
	const gchar* _tmp24_;
	gint _tmp25_;
	gint _tmp26_;
	gint* _tmp27_;
	gint _tmp27__length1;
	_data1_ = g_slice_new0 (Block1Data);
	_data1_->_ref_count_ = 1;
	_data1_->self = g_object_ref (self);
	if (self->priv->timeout > ((guint) 0)) {
		g_source_remove (self->priv->timeout);
	}
	wallet_card_number_entry_update_number (self);
	wallet_card_number_entry_detect_card (self);
	wallet_card_number_entry_change_card_icon (self);
	_tmp1_ = wallet_card_number_entry_get_card_pattern (self, &_tmp0_);
	pattern = _tmp1_;
	pattern_length1 = _tmp0_;
	_pattern_size_ = pattern_length1;
	_tmp2_ = self->priv->_card_number;
	_tmp4_ = string_to_utf8 (_tmp2_, &_tmp3_);
	number_chars = _tmp4_;
	number_chars_length1 = _tmp3_;
	_number_chars_size_ = number_chars_length1;
	_tmp5_ = g_string_new ("");
	builder = _tmp5_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp6_ = FALSE;
			_tmp6_ = TRUE;
			while (TRUE) {
				gchar* _tmp8_;
				gint _tmp8__length1;
				GString* _tmp9_;
				gchar* _tmp10_;
				gint _tmp10__length1;
				gchar _tmp11_;
				gboolean _tmp12_ = FALSE;
				gboolean _tmp13_ = FALSE;
				if (!_tmp6_) {
					gint _tmp7_;
					_tmp7_ = i;
					i = _tmp7_ + 1;
				}
				_tmp6_ = FALSE;
				_tmp8_ = number_chars;
				_tmp8__length1 = number_chars_length1;
				if (!(i < _tmp8__length1)) {
					break;
				}
				_tmp9_ = builder;
				_tmp10_ = number_chars;
				_tmp10__length1 = number_chars_length1;
				_tmp11_ = _tmp10_[i];
				g_string_append_c (_tmp9_, _tmp11_);
				if (self->priv->insertion) {
					_tmp13_ = TRUE;
				} else {
					gchar* _tmp14_;
					gint _tmp14__length1;
					_tmp14_ = number_chars;
					_tmp14__length1 = number_chars_length1;
					_tmp13_ = (i + 1) != _tmp14__length1;
				}
				if (_tmp13_) {
					gint* _tmp15_;
					gint _tmp15__length1;
					_tmp15_ = pattern;
					_tmp15__length1 = pattern_length1;
					_tmp12_ = _vala_int_array_contains (_tmp15_, _tmp15__length1, i + 1);
				} else {
					_tmp12_ = FALSE;
				}
				if (_tmp12_) {
					GString* _tmp16_;
					_tmp16_ = builder;
					g_string_append_c (_tmp16_, ' ');
				}
			}
		}
	}
	_tmp17_ = gtk_entry_get_text ((GtkEntry*) self);
	_tmp18_ = _tmp17_;
	g_object_get ((GtkEntry*) self, "cursor-position", &_tmp19_, NULL);
	_tmp20_ = _tmp19_;
	_data1_->end_offset = (g_utf8_strlen (_tmp18_, (gssize) -1) - 1) - _tmp20_;
	_tmp21_ = builder;
	_tmp22_ = _tmp21_->str;
	gtk_entry_set_text ((GtkEntry*) self, _tmp22_);
	_tmp23_ = gtk_entry_get_text ((GtkEntry*) self);
	_tmp24_ = _tmp23_;
	g_object_get ((GtkEntry*) self, "cursor-position", &_tmp25_, NULL);
	_tmp26_ = _tmp25_;
	_data1_->new_offset = (g_utf8_strlen (_tmp24_, (gssize) -1) - 1) - _tmp26_;
	if (_data1_->end_offset != _data1_->new_offset) {
		g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ____lambda7__gsource_func, block1_data_ref (_data1_), block1_data_unref);
	}
	_tmp27_ = pattern;
	_tmp27__length1 = pattern_length1;
	gtk_entry_set_max_length ((GtkEntry*) self, wallet_card_number_entry_get_card_max_length (self) + _tmp27__length1);
	_g_string_free0 (builder);
	number_chars = (g_free (number_chars), NULL);
	pattern = (g_free (pattern), NULL);
	block1_data_unref (_data1_);
	_data1_ = NULL;
}

static void
__wallet_card_number_entry___lambda6__gtk_editable_changed (GtkEditable* _sender,
                                                            gpointer self)
{
	_wallet_card_number_entry___lambda6_ ((WalletCardNumberEntry*) self);
}

static GObject *
wallet_card_number_entry_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	WalletCardNumberEntry * self;
	GThemedIcon* _tmp0_;
	GThemedIcon* _tmp1_;
	parent_class = G_OBJECT_CLASS (wallet_card_number_entry_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WALLET_TYPE_CARD_NUMBER_ENTRY, WalletCardNumberEntry);
	gtk_entry_set_input_purpose ((GtkEntry*) self, GTK_INPUT_PURPOSE_DIGITS);
	gtk_entry_set_max_length ((GtkEntry*) self, 26);
	gtk_entry_set_placeholder_text ((GtkEntry*) self, _ ("Card Number"));
	_tmp0_ = (GThemedIcon*) g_themed_icon_new_with_default_fallbacks ("payment-card-symbolic");
	_tmp1_ = _tmp0_;
	g_object_set ((GtkEntry*) self, "primary-icon-gicon", (GIcon*) _tmp1_, NULL);
	_g_object_unref0 (_tmp1_);
	g_signal_connect_object ((GtkEditable*) self, "delete-text", (GCallback) __wallet_card_number_entry___lambda4__gtk_editable_delete_text, self, 0);
	g_signal_connect_object ((GtkEditable*) self, "insert-text", (GCallback) __wallet_card_number_entry___lambda5__gtk_editable_insert_text, self, 0);
	g_signal_connect_object ((GtkEditable*) self, "changed", (GCallback) __wallet_card_number_entry___lambda6__gtk_editable_changed, self, 0);
	return obj;
}

static void
wallet_card_number_entry_class_init (WalletCardNumberEntryClass * klass,
                                     gpointer klass_data)
{
	wallet_card_number_entry_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &WalletCardNumberEntry_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_wallet_card_number_entry_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_wallet_card_number_entry_set_property;
	G_OBJECT_CLASS (klass)->constructor = wallet_card_number_entry_constructor;
	G_OBJECT_CLASS (klass)->finalize = wallet_card_number_entry_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), WALLET_CARD_NUMBER_ENTRY_CARD_NUMBER_PROPERTY, wallet_card_number_entry_properties[WALLET_CARD_NUMBER_ENTRY_CARD_NUMBER_PROPERTY] = g_param_spec_string ("card-number", "card-number", "card-number", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_PROPERTY, wallet_card_number_entry_properties[WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_PROPERTY] = g_param_spec_enum ("card-type", "card-type", "card-type", WALLET_CARD_NUMBER_ENTRY_TYPE_CARD_TYPE, WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_UNKNOWN, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
}

static void
wallet_card_number_entry_instance_init (WalletCardNumberEntry * self,
                                        gpointer klass)
{
	self->priv = wallet_card_number_entry_get_instance_private (self);
	self->priv->_card_type = WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_UNKNOWN;
	self->priv->timeout = (guint) 0;
	self->priv->insertion = TRUE;
}

static void
wallet_card_number_entry_finalize (GObject * obj)
{
	WalletCardNumberEntry * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WALLET_TYPE_CARD_NUMBER_ENTRY, WalletCardNumberEntry);
	_g_free0 (self->priv->_card_number);
	G_OBJECT_CLASS (wallet_card_number_entry_parent_class)->finalize (obj);
}

static GType
wallet_card_number_entry_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WalletCardNumberEntryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) wallet_card_number_entry_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WalletCardNumberEntry), 0, (GInstanceInitFunc) wallet_card_number_entry_instance_init, NULL };
	GType wallet_card_number_entry_type_id;
	wallet_card_number_entry_type_id = g_type_register_static (gtk_entry_get_type (), "WalletCardNumberEntry", &g_define_type_info, 0);
	WalletCardNumberEntry_private_offset = g_type_add_instance_private (wallet_card_number_entry_type_id, sizeof (WalletCardNumberEntryPrivate));
	return wallet_card_number_entry_type_id;
}

GType
wallet_card_number_entry_get_type (void)
{
	static volatile gsize wallet_card_number_entry_type_id__once = 0;
	if (g_once_init_enter (&wallet_card_number_entry_type_id__once)) {
		GType wallet_card_number_entry_type_id;
		wallet_card_number_entry_type_id = wallet_card_number_entry_get_type_once ();
		g_once_init_leave (&wallet_card_number_entry_type_id__once, wallet_card_number_entry_type_id);
	}
	return wallet_card_number_entry_type_id__once;
}

static void
_vala_wallet_card_number_entry_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec)
{
	WalletCardNumberEntry * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WALLET_TYPE_CARD_NUMBER_ENTRY, WalletCardNumberEntry);
	switch (property_id) {
		case WALLET_CARD_NUMBER_ENTRY_CARD_NUMBER_PROPERTY:
		g_value_set_string (value, wallet_card_number_entry_get_card_number (self));
		break;
		case WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_PROPERTY:
		g_value_set_enum (value, wallet_card_number_entry_get_card_type (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_wallet_card_number_entry_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec)
{
	WalletCardNumberEntry * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WALLET_TYPE_CARD_NUMBER_ENTRY, WalletCardNumberEntry);
	switch (property_id) {
		case WALLET_CARD_NUMBER_ENTRY_CARD_NUMBER_PROPERTY:
		wallet_card_number_entry_set_card_number (self, g_value_get_string (value));
		break;
		case WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_PROPERTY:
		wallet_card_number_entry_set_card_type (self, g_value_get_enum (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

