/* SecretItemRow.c generated by valac 0.56.12, the Vala compiler
 * generated from SecretItemRow.vala, do not modify */

/*
 * Copyright 2020 elementary, Inc.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "io.elementary.switchboard.wallet.h"
#include <gtk/gtk.h>
#include <libsecret/secret.h>
#include <glib-object.h>
#include <glib.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>

enum  {
	WALLET_SECRET_ITEM_ROW_0_PROPERTY,
	WALLET_SECRET_ITEM_ROW_CLOSE_REVEALER_PROPERTY,
	WALLET_SECRET_ITEM_ROW_SECRET_ITEM_PROPERTY,
	WALLET_SECRET_ITEM_ROW_NUM_PROPERTIES
};
static GParamSpec* wallet_secret_item_row_properties[WALLET_SECRET_ITEM_ROW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _WalletSecretItemRowDeleteSecretData WalletSecretItemRowDeleteSecretData;
typedef struct _Block2Data Block2Data;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))

struct _WalletSecretItemRowPrivate {
	GtkRevealer* _close_revealer;
	SecretItem* _secret_item;
};

struct _WalletSecretItemRowDeleteSecretData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	WalletSecretItemRow* self;
	SecretItem* _tmp0_;
	GError* _error_;
	GError* _tmp1_;
	const gchar* _tmp2_;
	GError* _inner_error0_;
};

struct _Block2Data {
	int _ref_count_;
	WalletSecretItemRow* self;
	GtkRevealer* revealer;
};

static gint WalletSecretItemRow_private_offset;
static gpointer wallet_secret_item_row_parent_class = NULL;
static GtkCssProvider* wallet_secret_item_row_css_provider;
static GtkCssProvider* wallet_secret_item_row_css_provider = NULL;

static void wallet_secret_item_row_delete_secret_data_free (gpointer _data);
static void wallet_secret_item_row_delete_secret (WalletSecretItemRow* self,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_);
static void wallet_secret_item_row_delete_secret_finish (WalletSecretItemRow* self,
                                                  GAsyncResult* _res_);
static gboolean wallet_secret_item_row_delete_secret_co (WalletSecretItemRowDeleteSecretData* _data_);
static void wallet_secret_item_row_delete_secret_ready (GObject* source_object,
                                                 GAsyncResult* _res_,
                                                 gpointer _user_data_);
static void wallet_secret_item_row_set_close_revealer (WalletSecretItemRow* self,
                                                GtkRevealer* value);
static GObject * wallet_secret_item_row_constructor (GType type,
                                              guint n_construct_properties,
                                              GObjectConstructParam * construct_properties);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static gboolean _wallet_secret_item_row___lambda13_ (Block2Data* _data2_);
static gboolean __lambda14_ (WalletSecretItemRow* self);
static gboolean ___lambda14__gsource_func (gpointer self);
static gboolean __wallet_secret_item_row___lambda13__gtk_widget_button_release_event (GtkWidget* _sender,
                                                                               GdkEventButton* event,
                                                                               gpointer self);
static gboolean _wallet_secret_item_row___lambda15_ (WalletSecretItemRow* self);
static gboolean __wallet_secret_item_row___lambda15__gtk_widget_focus_out_event (GtkWidget* _sender,
                                                                          GdkEventFocus* event,
                                                                          gpointer self);
static void wallet_secret_item_row_finalize (GObject * obj);
static GType wallet_secret_item_row_get_type_once (void);
static void _vala_wallet_secret_item_row_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_wallet_secret_item_row_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);

static inline gpointer
wallet_secret_item_row_get_instance_private (WalletSecretItemRow* self)
{
	return G_STRUCT_MEMBER_P (self, WalletSecretItemRow_private_offset);
}

WalletSecretItemRow*
wallet_secret_item_row_construct (GType object_type,
                                  SecretItem* secret_item)
{
	WalletSecretItemRow * self = NULL;
	g_return_val_if_fail (secret_item != NULL, NULL);
	self = (WalletSecretItemRow*) g_object_new (object_type, "secret-item", secret_item, NULL);
	return self;
}

WalletSecretItemRow*
wallet_secret_item_row_new (SecretItem* secret_item)
{
	return wallet_secret_item_row_construct (WALLET_TYPE_SECRET_ITEM_ROW, secret_item);
}

static void
wallet_secret_item_row_delete_secret_data_free (gpointer _data)
{
	WalletSecretItemRowDeleteSecretData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (WalletSecretItemRowDeleteSecretData, _data_);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
wallet_secret_item_row_delete_secret (WalletSecretItemRow* self,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_)
{
	WalletSecretItemRowDeleteSecretData* _data_;
	WalletSecretItemRow* _tmp0_;
	g_return_if_fail (self != NULL);
	_data_ = g_slice_new0 (WalletSecretItemRowDeleteSecretData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, wallet_secret_item_row_delete_secret_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	wallet_secret_item_row_delete_secret_co (_data_);
}

static void
wallet_secret_item_row_delete_secret_finish (WalletSecretItemRow* self,
                                             GAsyncResult* _res_)
{
	WalletSecretItemRowDeleteSecretData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static void
wallet_secret_item_row_delete_secret_ready (GObject* source_object,
                                            GAsyncResult* _res_,
                                            gpointer _user_data_)
{
	WalletSecretItemRowDeleteSecretData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	wallet_secret_item_row_delete_secret_co (_data_);
}

static gboolean
wallet_secret_item_row_delete_secret_co (WalletSecretItemRowDeleteSecretData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	{
		_data_->_tmp0_ = _data_->self->priv->_secret_item;
		_data_->_state_ = 1;
		secret_item_delete (_data_->_tmp0_, NULL, wallet_secret_item_row_delete_secret_ready, _data_);
		return FALSE;
		_state_1:
		secret_item_delete_finish (_data_->_tmp0_, _data_->_res_, &_data_->_inner_error0_);
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		gtk_widget_destroy ((GtkWidget*) _data_->self);
	}
	goto __finally0;
	__catch0_g_error:
	{
		_data_->_error_ = _data_->_inner_error0_;
		_data_->_inner_error0_ = NULL;
		_data_->_tmp1_ = _data_->_error_;
		_data_->_tmp2_ = _data_->_tmp1_->message;
		g_critical ("SecretItemRow.vala:112: %s", _data_->_tmp2_);
		_g_error_free0 (_data_->_error_);
	}
	__finally0:
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
		g_clear_error (&_data_->_inner_error0_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

GtkRevealer*
wallet_secret_item_row_get_close_revealer (WalletSecretItemRow* self)
{
	GtkRevealer* result;
	GtkRevealer* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_close_revealer;
	result = _tmp0_;
	return result;
}

static void
wallet_secret_item_row_set_close_revealer (WalletSecretItemRow* self,
                                           GtkRevealer* value)
{
	GtkRevealer* old_value;
	g_return_if_fail (self != NULL);
	old_value = wallet_secret_item_row_get_close_revealer (self);
	if (old_value != value) {
		GtkRevealer* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_close_revealer);
		self->priv->_close_revealer = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, wallet_secret_item_row_properties[WALLET_SECRET_ITEM_ROW_CLOSE_REVEALER_PROPERTY]);
	}
}

SecretItem*
wallet_secret_item_row_get_secret_item (WalletSecretItemRow* self)
{
	SecretItem* result;
	SecretItem* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_secret_item;
	result = _tmp0_;
	return result;
}

static void
wallet_secret_item_row_set_secret_item (WalletSecretItemRow* self,
                                        SecretItem* value)
{
	SecretItem* old_value;
	g_return_if_fail (self != NULL);
	old_value = wallet_secret_item_row_get_secret_item (self);
	if (old_value != value) {
		SecretItem* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_secret_item);
		self->priv->_secret_item = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, wallet_secret_item_row_properties[WALLET_SECRET_ITEM_ROW_SECRET_ITEM_PROPERTY]);
	}
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
	g_atomic_int_inc (&_data2_->_ref_count_);
	return _data2_;
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
		WalletSecretItemRow* self;
		self = _data2_->self;
		_g_object_unref0 (_data2_->revealer);
		_g_object_unref0 (self);
		g_slice_free (Block2Data, _data2_);
	}
}

static gboolean
__lambda14_ (WalletSecretItemRow* self)
{
	gboolean result;
	wallet_secret_item_row_delete_secret (self, NULL, NULL);
	result = GDK_EVENT_STOP;
	return result;
}

static gboolean
___lambda14__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda14_ ((WalletSecretItemRow*) self);
	return result;
}

static gboolean
_wallet_secret_item_row___lambda13_ (Block2Data* _data2_)
{
	WalletSecretItemRow* self;
	GtkRevealer* _tmp0_;
	GtkRevealer* _tmp1_;
	GtkRevealer* _tmp2_;
	guint _tmp3_;
	guint _tmp4_;
	self = _data2_->self;
	_tmp0_ = _data2_->revealer;
	gtk_revealer_set_transition_duration (_tmp0_, (guint) 195);
	_tmp1_ = _data2_->revealer;
	gtk_revealer_set_reveal_child (_tmp1_, FALSE);
	_tmp2_ = _data2_->revealer;
	_tmp3_ = gtk_revealer_get_transition_duration (_tmp2_);
	_tmp4_ = _tmp3_;
	g_timeout_add_full (G_PRIORITY_DEFAULT, _tmp4_, ___lambda14__gsource_func, g_object_ref (self), g_object_unref);
}

static gboolean
__wallet_secret_item_row___lambda13__gtk_widget_button_release_event (GtkWidget* _sender,
                                                                      GdkEventButton* event,
                                                                      gpointer self)
{
	gboolean result;
	result = _wallet_secret_item_row___lambda13_ (self);
	return result;
}

static gboolean
_wallet_secret_item_row___lambda15_ (WalletSecretItemRow* self)
{
	GtkRevealer* _tmp0_;
	_tmp0_ = self->priv->_close_revealer;
	gtk_revealer_set_reveal_child (_tmp0_, FALSE);
}

static gboolean
__wallet_secret_item_row___lambda15__gtk_widget_focus_out_event (GtkWidget* _sender,
                                                                 GdkEventFocus* event,
                                                                 gpointer self)
{
	gboolean result;
	result = _wallet_secret_item_row___lambda15_ ((WalletSecretItemRow*) self);
	return result;
}

static GObject *
wallet_secret_item_row_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	WalletSecretItemRow * self;
	Block2Data* _data2_;
	GtkImage* delete_image = NULL;
	GtkImage* _tmp0_;
	GtkImage* _tmp1_;
	GtkStyleContext* _tmp2_;
	GtkCssProvider* _tmp3_;
	GtkButton* delete_button = NULL;
	GtkButton* _tmp4_;
	GtkButton* _tmp5_;
	GtkImage* _tmp6_;
	GtkButton* _tmp7_;
	GtkButton* _tmp8_;
	GtkButton* _tmp9_;
	GtkStyleContext* delete_button_context = NULL;
	GtkButton* _tmp10_;
	GtkStyleContext* _tmp11_;
	GtkStyleContext* _tmp12_;
	GtkStyleContext* _tmp13_;
	GtkCssProvider* _tmp14_;
	GtkRevealer* _tmp15_;
	GtkRevealer* _tmp16_;
	GtkRevealer* _tmp17_;
	GtkRevealer* _tmp18_;
	GtkButton* _tmp19_;
	GtkImage* image = NULL;
	GtkImage* _tmp20_;
	GtkImage* _tmp21_;
	GtkLabel* title_label = NULL;
	SecretItem* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	GtkLabel* _tmp25_;
	GtkLabel* _tmp26_;
	GtkLabel* _tmp27_;
	GtkLabel* _tmp28_;
	GtkLabel* description = NULL;
	GtkLabel* _tmp29_;
	GtkLabel* _tmp30_;
	GtkLabel* _tmp31_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp32_;
	GtkGrid* _tmp33_;
	GtkGrid* _tmp34_;
	GtkGrid* _tmp35_;
	GtkGrid* _tmp36_;
	GtkRevealer* _tmp37_;
	GtkGrid* _tmp38_;
	GtkImage* _tmp39_;
	GtkGrid* _tmp40_;
	GtkLabel* _tmp41_;
	GtkGrid* _tmp42_;
	GtkLabel* _tmp43_;
	GtkRevealer* _tmp44_;
	GtkRevealer* _tmp45_;
	GtkRevealer* _tmp46_;
	GtkRevealer* _tmp47_;
	GtkGrid* _tmp48_;
	GtkRevealer* _tmp49_;
	GHashTable* attributes = NULL;
	SecretItem* _tmp50_;
	GHashTable* _tmp51_;
	gchar* exp = NULL;
	GHashTable* _tmp52_;
	gconstpointer _tmp53_;
	gchar* _tmp54_;
	const gchar* _tmp55_;
	gchar* brand = NULL;
	GHashTable* _tmp68_;
	gconstpointer _tmp69_;
	gchar* _tmp70_;
	const gchar* _tmp71_;
	GtkButton* _tmp78_;
	parent_class = G_OBJECT_CLASS (wallet_secret_item_row_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WALLET_TYPE_SECRET_ITEM_ROW, WalletSecretItemRow);
	_data2_ = g_slice_new0 (Block2Data);
	_data2_->_ref_count_ = 1;
	_data2_->self = g_object_ref (self);
	_tmp0_ = (GtkImage*) gtk_image_new_from_icon_name ("window-close-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
	g_object_ref_sink (_tmp0_);
	delete_image = _tmp0_;
	_tmp1_ = delete_image;
	_tmp2_ = gtk_widget_get_style_context ((GtkWidget*) _tmp1_);
	_tmp3_ = wallet_secret_item_row_css_provider;
	gtk_style_context_add_provider (_tmp2_, (GtkStyleProvider*) _tmp3_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
	_tmp4_ = (GtkButton*) gtk_button_new ();
	g_object_ref_sink (_tmp4_);
	delete_button = _tmp4_;
	_tmp5_ = delete_button;
	_tmp6_ = delete_image;
	gtk_button_set_image (_tmp5_, (GtkWidget*) _tmp6_);
	_tmp7_ = delete_button;
	gtk_widget_set_margin_start ((GtkWidget*) _tmp7_, 6);
	_tmp8_ = delete_button;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp8_, _ ("Delete"));
	_tmp9_ = delete_button;
	gtk_widget_set_valign ((GtkWidget*) _tmp9_, GTK_ALIGN_CENTER);
	_tmp10_ = delete_button;
	_tmp11_ = gtk_widget_get_style_context ((GtkWidget*) _tmp10_);
	delete_button_context = _tmp11_;
	_tmp12_ = delete_button_context;
	gtk_style_context_add_class (_tmp12_, "delete");
	_tmp13_ = delete_button_context;
	_tmp14_ = wallet_secret_item_row_css_provider;
	gtk_style_context_add_provider (_tmp13_, (GtkStyleProvider*) _tmp14_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
	_tmp15_ = (GtkRevealer*) gtk_revealer_new ();
	g_object_ref_sink (_tmp15_);
	_tmp16_ = _tmp15_;
	wallet_secret_item_row_set_close_revealer (self, _tmp16_);
	_g_object_unref0 (_tmp16_);
	_tmp17_ = self->priv->_close_revealer;
	gtk_revealer_set_transition_type (_tmp17_, GTK_REVEALER_TRANSITION_TYPE_SLIDE_RIGHT);
	_tmp18_ = self->priv->_close_revealer;
	_tmp19_ = delete_button;
	gtk_container_add ((GtkContainer*) _tmp18_, (GtkWidget*) _tmp19_);
	_tmp20_ = (GtkImage*) gtk_image_new_from_icon_name ("payment-card", (GtkIconSize) GTK_ICON_SIZE_DND);
	g_object_ref_sink (_tmp20_);
	image = _tmp20_;
	_tmp21_ = image;
	g_object_set (_tmp21_, "use-fallback", TRUE, NULL);
	_tmp22_ = self->priv->_secret_item;
	_tmp23_ = secret_item_get_label (_tmp22_);
	_tmp24_ = _tmp23_;
	_tmp25_ = (GtkLabel*) gtk_label_new (_tmp24_);
	g_object_ref_sink (_tmp25_);
	_tmp26_ = _tmp25_;
	_g_free0 (_tmp24_);
	title_label = _tmp26_;
	_tmp27_ = title_label;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp27_, TRUE);
	_tmp28_ = title_label;
	gtk_label_set_xalign (_tmp28_, (gfloat) 0);
	_tmp29_ = (GtkLabel*) gtk_label_new (NULL);
	g_object_ref_sink (_tmp29_);
	description = _tmp29_;
	_tmp30_ = description;
	gtk_label_set_use_markup (_tmp30_, TRUE);
	_tmp31_ = description;
	gtk_label_set_xalign (_tmp31_, (gfloat) 0);
	_tmp32_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp32_);
	grid = _tmp32_;
	_tmp33_ = grid;
	gtk_grid_set_column_spacing (_tmp33_, 6);
	_tmp34_ = grid;
	g_object_set ((GtkWidget*) _tmp34_, "margin", 6, NULL);
	_tmp35_ = grid;
	gtk_widget_set_margin_start ((GtkWidget*) _tmp35_, 0);
	_tmp36_ = grid;
	_tmp37_ = self->priv->_close_revealer;
	gtk_grid_attach (_tmp36_, (GtkWidget*) _tmp37_, 0, 0, 1, 2);
	_tmp38_ = grid;
	_tmp39_ = image;
	gtk_grid_attach (_tmp38_, (GtkWidget*) _tmp39_, 1, 0, 1, 2);
	_tmp40_ = grid;
	_tmp41_ = title_label;
	gtk_grid_attach (_tmp40_, (GtkWidget*) _tmp41_, 2, 0, 1, 1);
	_tmp42_ = grid;
	_tmp43_ = description;
	gtk_grid_attach (_tmp42_, (GtkWidget*) _tmp43_, 2, 1, 1, 1);
	_tmp44_ = (GtkRevealer*) gtk_revealer_new ();
	g_object_ref_sink (_tmp44_);
	_data2_->revealer = _tmp44_;
	_tmp45_ = _data2_->revealer;
	gtk_revealer_set_reveal_child (_tmp45_, TRUE);
	_tmp46_ = _data2_->revealer;
	gtk_revealer_set_transition_type (_tmp46_, GTK_REVEALER_TRANSITION_TYPE_SLIDE_UP);
	_tmp47_ = _data2_->revealer;
	_tmp48_ = grid;
	gtk_container_add ((GtkContainer*) _tmp47_, (GtkWidget*) _tmp48_);
	_tmp49_ = _data2_->revealer;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp49_);
	_tmp50_ = self->priv->_secret_item;
	_tmp51_ = secret_item_get_attributes (_tmp50_);
	attributes = _tmp51_;
	_tmp52_ = attributes;
	_tmp53_ = g_hash_table_lookup (_tmp52_, "exp");
	_tmp54_ = g_strdup ((const gchar*) _tmp53_);
	exp = _tmp54_;
	_tmp55_ = exp;
	if (_tmp55_ != NULL) {
		GtkLabel* _tmp56_;
		const gchar* _tmp57_;
		gchar* _tmp58_;
		gchar* _tmp59_;
		gchar* _tmp60_;
		gchar* _tmp61_;
		_tmp56_ = description;
		_tmp57_ = exp;
		_tmp58_ = g_strdup_printf (_ ("Expires %s"), _tmp57_);
		_tmp59_ = _tmp58_;
		_tmp60_ = g_strdup_printf ("<small>%s</small>", _tmp59_);
		_tmp61_ = _tmp60_;
		gtk_label_set_label (_tmp56_, _tmp61_);
		_g_free0 (_tmp61_);
		_g_free0 (_tmp59_);
	} else {
		GtkLabel* _tmp62_;
		SecretItem* _tmp63_;
		gchar* _tmp64_;
		gchar* _tmp65_;
		gchar* _tmp66_;
		gchar* _tmp67_;
		_tmp62_ = description;
		_tmp63_ = self->priv->_secret_item;
		_tmp64_ = secret_item_get_schema_name (_tmp63_);
		_tmp65_ = _tmp64_;
		_tmp66_ = g_strdup_printf ("<small>%s</small>", _tmp65_);
		_tmp67_ = _tmp66_;
		gtk_label_set_label (_tmp62_, _tmp67_);
		_g_free0 (_tmp67_);
		_g_free0 (_tmp65_);
	}
	_tmp68_ = attributes;
	_tmp69_ = g_hash_table_lookup (_tmp68_, "brand");
	_tmp70_ = g_strdup ((const gchar*) _tmp69_);
	brand = _tmp70_;
	_tmp71_ = brand;
	if (_tmp71_ != NULL) {
		GtkImage* _tmp72_;
		const gchar* _tmp73_;
		gchar* _tmp74_;
		gchar* _tmp75_;
		gchar* _tmp76_;
		gchar* _tmp77_;
		_tmp72_ = image;
		_tmp73_ = brand;
		_tmp74_ = g_utf8_strdown (_tmp73_, (gssize) -1);
		_tmp75_ = _tmp74_;
		_tmp76_ = g_strdup_printf ("payment-card-%s", _tmp75_);
		_tmp77_ = _tmp76_;
		g_object_set (_tmp72_, "icon-name", _tmp77_, NULL);
		_g_free0 (_tmp77_);
		_g_free0 (_tmp75_);
	}
	_tmp78_ = delete_button;
	g_signal_connect_data ((GtkWidget*) _tmp78_, "button-release-event", (GCallback) __wallet_secret_item_row___lambda13__gtk_widget_button_release_event, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
	g_signal_connect_object ((GtkWidget*) self, "focus-out-event", (GCallback) __wallet_secret_item_row___lambda15__gtk_widget_focus_out_event, self, 0);
	_g_free0 (brand);
	_g_free0 (exp);
	_g_hash_table_unref0 (attributes);
	_g_object_unref0 (grid);
	_g_object_unref0 (description);
	_g_object_unref0 (title_label);
	_g_object_unref0 (image);
	_g_object_unref0 (delete_button);
	_g_object_unref0 (delete_image);
	block2_data_unref (_data2_);
	_data2_ = NULL;
	return obj;
}

static void
wallet_secret_item_row_class_init (WalletSecretItemRowClass * klass,
                                   gpointer klass_data)
{
	GtkCssProvider* _tmp0_;
	GtkCssProvider* _tmp1_;
	wallet_secret_item_row_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &WalletSecretItemRow_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_wallet_secret_item_row_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_wallet_secret_item_row_set_property;
	G_OBJECT_CLASS (klass)->constructor = wallet_secret_item_row_constructor;
	G_OBJECT_CLASS (klass)->finalize = wallet_secret_item_row_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), WALLET_SECRET_ITEM_ROW_CLOSE_REVEALER_PROPERTY, wallet_secret_item_row_properties[WALLET_SECRET_ITEM_ROW_CLOSE_REVEALER_PROPERTY] = g_param_spec_object ("close-revealer", "close-revealer", "close-revealer", gtk_revealer_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WALLET_SECRET_ITEM_ROW_SECRET_ITEM_PROPERTY, wallet_secret_item_row_properties[WALLET_SECRET_ITEM_ROW_SECRET_ITEM_PROPERTY] = g_param_spec_object ("secret-item", "secret-item", "secret-item", secret_item_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	_tmp0_ = gtk_css_provider_new ();
	_g_object_unref0 (wallet_secret_item_row_css_provider);
	wallet_secret_item_row_css_provider = _tmp0_;
	_tmp1_ = wallet_secret_item_row_css_provider;
	gtk_css_provider_load_from_resource (_tmp1_, "io/elementary/switchboard/wallet/SecretItemRow.css");
}

static void
wallet_secret_item_row_instance_init (WalletSecretItemRow * self,
                                      gpointer klass)
{
	self->priv = wallet_secret_item_row_get_instance_private (self);
}

static void
wallet_secret_item_row_finalize (GObject * obj)
{
	WalletSecretItemRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WALLET_TYPE_SECRET_ITEM_ROW, WalletSecretItemRow);
	_g_object_unref0 (self->priv->_close_revealer);
	_g_object_unref0 (self->priv->_secret_item);
	G_OBJECT_CLASS (wallet_secret_item_row_parent_class)->finalize (obj);
}

static GType
wallet_secret_item_row_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WalletSecretItemRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) wallet_secret_item_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WalletSecretItemRow), 0, (GInstanceInitFunc) wallet_secret_item_row_instance_init, NULL };
	GType wallet_secret_item_row_type_id;
	wallet_secret_item_row_type_id = g_type_register_static (gtk_list_box_row_get_type (), "WalletSecretItemRow", &g_define_type_info, 0);
	WalletSecretItemRow_private_offset = g_type_add_instance_private (wallet_secret_item_row_type_id, sizeof (WalletSecretItemRowPrivate));
	return wallet_secret_item_row_type_id;
}

GType
wallet_secret_item_row_get_type (void)
{
	static volatile gsize wallet_secret_item_row_type_id__once = 0;
	if (g_once_init_enter (&wallet_secret_item_row_type_id__once)) {
		GType wallet_secret_item_row_type_id;
		wallet_secret_item_row_type_id = wallet_secret_item_row_get_type_once ();
		g_once_init_leave (&wallet_secret_item_row_type_id__once, wallet_secret_item_row_type_id);
	}
	return wallet_secret_item_row_type_id__once;
}

static void
_vala_wallet_secret_item_row_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	WalletSecretItemRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WALLET_TYPE_SECRET_ITEM_ROW, WalletSecretItemRow);
	switch (property_id) {
		case WALLET_SECRET_ITEM_ROW_CLOSE_REVEALER_PROPERTY:
		g_value_set_object (value, wallet_secret_item_row_get_close_revealer (self));
		break;
		case WALLET_SECRET_ITEM_ROW_SECRET_ITEM_PROPERTY:
		g_value_set_object (value, wallet_secret_item_row_get_secret_item (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_wallet_secret_item_row_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	WalletSecretItemRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WALLET_TYPE_SECRET_ITEM_ROW, WalletSecretItemRow);
	switch (property_id) {
		case WALLET_SECRET_ITEM_ROW_CLOSE_REVEALER_PROPERTY:
		wallet_secret_item_row_set_close_revealer (self, g_value_get_object (value));
		break;
		case WALLET_SECRET_ITEM_ROW_SECRET_ITEM_PROPERTY:
		wallet_secret_item_row_set_secret_item (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

